
/**********************************************************************
 *           gamefield.h  -  description 
 *           Project: "Labyrinth"
 *
 *           (C) 2003 by Helge Plehn
 *           29.03.2003
 *                                                                         
 *   This program is free software; you can redistribute it and/or modify  
 *   it under the terms of the GNU General Public License as published by 
 *   the Free Software Foundation; either version 2 of the License, or     
 *   (at your option) any later version.                               
 *                                                                    
**********************************************************************/


#ifndef GAMEFIELD_H
#define GAMEFIELD_H


#include <qwidget.h>
#include <qarray.h>
#include <qpoint.h>
#include <qmessagebox.h>
#include <qpainter.h>
#include <qpixmap.h>
#include <qbitmap.h>
#include <qpaintdevice.h>

//#include <math.h>

#include "myline.h"
#include "myblock.h"


class GameField : public QWidget
{
Q_OBJECT
public:
 GameField( QWidget *parent=0, const char *name=0 );

public slots:
 void StartGame();
 void StopGame();
 void PauseGame();
 void spacepressed();
 void SetTiltVector( QPoint );
 void SetCursorVector( QPoint );
 void ChangeCheatMode(bool);
 //void ChangeFriction(bool);
  
signals:

 void SetTime( long );
 void setgamemode( int );
 void TiltVectorChange( QPoint );
 void CursorVectorChange( QPoint );
 void SpeedVectorChange( QPoint );


protected:
 void timerEvent( QTimerEvent * );
 //void paintEvent( QPaintEvent * );


 void mouseMoveEvent( QMouseEvent *e );
 void mouseReleaseEvent(  QMouseEvent *e );
 void mousePressEvent( QMouseEvent *e );

 void Mausabfrage( QMouseEvent *e );

private:

 int Signum( int );
 QPoint CalcTiltVector( QPoint );

 
 void DefineArrays();
 void MoveSprites();

 
 int GameMode;		/* 	0 = vor dem Start
 											1 = Pause
 											2 = Normal
                     -1 = Game Over
                     -2 = Won! */
                     
 int BallMode;    /*  0 = invisible
                      1 = Normal */

 long GameTime;
                       
 QPoint BallPosition;
 QPoint BallSpeed;
 QPoint SpeedAdd;
 QPoint TiltVector;
 QPoint CursorVector;

 QPoint MousePosition;
 bool MouseOverWidget;

 // Arrays
 QPoint Holes[40];
 
 //MyLine ObstacleEdges[189];
 //MyLine ObstacleCorners[143];

 MyBlock Obstacles[56];
    
 //Bitmaps
 QPixmap labyrinthimage;
 QPixmap gameimage;
 QPixmap ballimage;
 QBitmap ballmask;
 QPixmap ballcopy;
 
 bool CheatMode;
 //bool Friction;

};

#endif // GAMEFIELD_H


