
/**********************************************************************
 *           myblock.h  -  description
 *           Project: "Labyrinth"
 *
 *           (C) 2003 by Helge Plehn
 *           29.03.2003
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
**********************************************************************/


#ifndef MYBLOCK_H
#define MYBLOCK_H

#include <qwidget.h>
#include <qarray.h>
#include <qpoint.h>
//#include <math.h>

#include "myline.h"

class MyBlock 
{
//Q_OBJECT  // no inheritation from any Q_Object
public:
 MyBlock();
 MyBlock( QPoint P1, QPoint P2 );
 
 void SetP1( QPoint P1 );
 void SetP2( QPoint P2 );
 QPoint GetP1();
 QPoint GetP2();
 int MinX();
 int MinY();
 int MaxX();
 int MaxY();
 
 bool IsInside(QPoint Position);
 MyLine Schnittpunkt(QPoint, QPoint, QPoint, QPoint );
 QPoint Reflection(QPoint Position, QPoint Schnittpunkt, int Kante, int Index);
 QPoint SpeedReflection(QPoint Speed, int Kante, int Index, int Limit);

 unsigned long PunktAbstand( QPoint, QPoint );

 /*
 QString StringFromNumber( int Number );
 QString StringFromNumber( long int Number );
 QString StringFromNumber( unsigned long int Number );
 QString StringFromNumber( QPoint Punkt );
 QString StringFromNumber( MyLine Line );
 */
 
 private:

 QPoint SpeedDamping(QPoint Speed, int Index, int Limit);
 
 void Initialisierung();

 int Signum(int);
 
 QPoint Punkt1;
 QPoint Punkt2;

 int MinimumX;
 int MaximumX;
 int MinimumY;
 int MaximumY;

 QPoint InnenEcken[4];
 QPoint AussenEcken[4];
 MyLine Begrenzungslinien[4];
 MyLine EckKanten[4];

 MyLine EckKantenRotiert[4];

 
};

#endif // MYBLOCK_H
 
