/**********************************************************************
 *           myline.cpp  -  description
 *           Project: "Labyrinth"
 *
 *           (C) 2003 by Helge Plehn
 *           29.03.2003
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
**********************************************************************/

#include "myline.h"
//#include <qwidget.h>
//#include <qpoint.h>
//#include <math.h>

MyLine::MyLine( QPoint P1, QPoint P2 )
{
  // Constructer
  Punkt1 = P1;
  Punkt2 = P2;
  LineType = QString("");  
} 

MyLine::MyLine( QPoint P1, QPoint P2, QString linetype )
{
  // Alternativer Constructer
  Punkt1 = P1;
  Punkt2 = P2;
  LineType = linetype;
}

MyLine::MyLine( )
{
  // Alternativer Constructer
  Punkt1 = QPoint(0,0);
  Punkt2 = QPoint(0,0);
  LineType = QString("");
}
 
void MyLine::SetP1( QPoint P1 )
{  Punkt1 = P1; }
 
void MyLine::SetP2( QPoint P2 )
{  Punkt2 = P2; }

QPoint MyLine::GetP1( )
{ return Punkt1; }

QPoint MyLine::GetP2( )
{ return Punkt2; }

void MyLine::SetLineType( QString linetype )
{ LineType = linetype; }

QString MyLine::GetLineType( )
{ return LineType; }


int MyLine::DeltaX()
{ return ( Punkt2.x() - Punkt1.x() ); }

int MyLine::DeltaY()
{ return ( Punkt2.y() - Punkt1.y() ); }

int MyLine::MinX()
{
  if( Punkt1.x() < Punkt2.x() ) {
    return Punkt1.x();
  }
  else {
    return Punkt2.x();
  };
}

int MyLine::MinY()
{
  if( Punkt1.y() < Punkt2.y() ) {
    return Punkt1.y();
  }
  else {
    return Punkt2.y();
  };
}

int MyLine::MaxX()
{
  if( Punkt1.x() > Punkt2.x() ) {
    return Punkt1.x();
  }
  else {
    return Punkt2.x();
  };
}

int MyLine::MaxY()
{
  if( Punkt1.y() > Punkt2.y() ) {
    return Punkt1.y();
  }
  else {
    return Punkt2.y();
  };
}


QPoint MyLine::Intersection( MyLine OtherLine )
{
  // Gibt den Schnittpunkt mit der anderen Linie zurck
  // NUR FUER ORTHOGONALE LINIEN !!!
  QPoint Schnittpunkt;
  //float a;
  //float b;
  
  //if ( (MaxX() < OtherLine.MinX()) || (MinX() > OtherLine.MaxX()) || (MaxY() < OtherLine.MinY()) || (MinY() > OtherLine.MaxY()) ) return QPoint(0,0); // Die beiden Linien schneiden sich nicht!
  
  if ( DeltaX() == 0 ) {
    // senkrecht
    Schnittpunkt.setX( Punkt2.x() );

    //Schnittpunktberechnung
    if ( OtherLine.DeltaY() == 0 || OtherLine.DeltaX() == 0 ) {
      // OtherLine ist waagerecht! ( Oder, unwahrscheinlicher, befindet sich auf der Linie.)
      Schnittpunkt.setY( OtherLine.GetP1().y() );
    }
    else {
      //a = static_cast<float>( OtherLine.DeltaX() )/static_cast<float>( OtherLine.DeltaY() );
      //b = static_cast<float>( OtherLine.GetP1().x() ) - a*static_cast<float>( OtherLine.GetP1().y() );
      //Schnittpunkt.setY( static_cast<int>( ( static_cast<float>(Schnittpunkt.x()) -b )/a ) );
      Schnittpunkt.setY( ((Schnittpunkt.x()-OtherLine.GetP1().x())*OtherLine.DeltaY())/OtherLine.DeltaX() + OtherLine.GetP1().y());
      
    };
    
    //if( IsOnLine(Schnittpunkt) ) 
    return Schnittpunkt;

  };

  if ( DeltaY() == 0 ) {
    // waagerecht
    Schnittpunkt.setY( Punkt2.y() );

    //Schnittpunktberechnung
    if ( OtherLine.DeltaX() == 0 || OtherLine.DeltaY() == 0) {
      // OtherLine ist senkrecht!  ( Oder, unwahrscheinlicher, befindet sich auf der Linie.)
      Schnittpunkt.setX( OtherLine.GetP1().x() );
    }
    else {
      //a = static_cast<float>( OtherLine.DeltaY() )/static_cast<float>( OtherLine.DeltaX() );
      //b = static_cast<float>( OtherLine.GetP1().y() ) - a*static_cast<float>( OtherLine.GetP1().x() );
      //Schnittpunkt.setX( static_cast<int>( ( static_cast<float>(Schnittpunkt.y()) -b )/a ) );

      Schnittpunkt.setX( ((Schnittpunkt.y()-OtherLine.GetP1().y())*OtherLine.DeltaX())/OtherLine.DeltaY() + OtherLine.GetP1().x());

    };

    //if( IsOnLine(Schnittpunkt) ) 
    return Schnittpunkt;

  };
  
  // Kein Schnittpunkt gefunden, Linie ist nicht orthogonal!
  //qDebug( " Linie nicht orthogonal! " );         
  return QPoint(0,0);
  
}

 
   
bool MyLine::IsOnLine( QPoint Punkt )
{
  // berprft, ob sich Punkt auf der Linie MyLine befindet.
  // NUR FUER ORTHOGONALE LINIEN !!!
  if ( DeltaX() == 0 )
  {
    // senkrecht
    return ( Punkt.y()>=MinY() && Punkt.y() <= MaxY() && Punkt.x() == Punkt1.x() );
  };
  if ( DeltaY() == 0 )
  {
    // waagerecht
    return ( Punkt.x()>=MinX() && Punkt.x() <= MaxX() && Punkt.y() == Punkt1.y() );
  };
  return false;
}



QPoint MyLine::Rotate45( QPoint Punkt, long Richtung )
{
  // Berechnet die Rotation um 45 um den Koordinatenursprung
  // Richtung = 1 -> 45, Richtung = -1 -> -45

  long sin45 = 5793; // sin(45) = 0.70711 ca. 0.70715 = 5793/8192
  long &cos45 = sin45; // = 362, Referenz auf den Sinuswert;
  long Xlong = static_cast<long>(Punkt.x());
  long Ylong = static_cast<long>(Punkt.y());

  if ( Richtung != -1 && Richtung != 1) Richtung = 1;

  return QPoint( static_cast<int>( ( cos45*Xlong - Richtung*sin45*Ylong )/8192 ), static_cast<int>( ( Richtung*sin45*Xlong + cos45*Ylong  )/8192 ) );

}




 
