
/**********************************************************************
 *           showvector.cpp  -  description
 *           Project: "Labyrinth"
 *
 *           (C) 2003 by Helge Plehn
 *           29.03.2003
 *
 *   This program is free software; you can redistribute it and/or modify
 *   it under the terms of the GNU General Public License as published by
 *   the Free Software Foundation; either version 2 of the License, or
 *   (at your option) any later version.
 *
**********************************************************************/

#include "showvector.h"

#include <math.h>


ShowVector::ShowVector( QWidget *parent, const char *name )
: QWidget( parent, name )
{
  // Konstrukter
  //setMouseTracking ( true );
  setPalette( QPalette( black ) );
  setCursor(QCursor(10));  
  repaint();
}

void ShowVector::mousePressEvent( QMouseEvent *e )
{
  Mausabfrage(e);
}

void ShowVector::mouseMoveEvent( QMouseEvent *e )
{
  Mausabfrage(e); 
}


void ShowVector::Mausabfrage( QMouseEvent *e )
{
 QPoint MousePosition;
 
 MousePosition = e -> pos();
 MousePosition.setX(MousePosition.x() - 24-8);
 MousePosition.setY(MousePosition.y() - 24-6);

 emit TiltVectorChange(MousePosition);
 
}



void ShowVector::SetTiltVector( QPoint Vector )
{
  if ( TiltVector == Vector ) return;
  TiltVector = Vector;
  repaint();
}

void ShowVector::SetSpeedVector( QPoint Vector )
{
  if ( BallSpeed == Vector ) return;
  BallSpeed = Vector;
  repaint();
}



void ShowVector::paintEvent( QPaintEvent * )
{
  QPixmap Abbild( 64, 56, -1 );

  Abbild.fill( black );
  
  QPainter p( &Abbild );
  QPoint DisplaySpeed;
  float AbsWert;

  
  p.setPen( NoPen );
  
  p.setBrush( QColor( 168, 137, 112  ) );
  p.drawEllipse( 8, 4, 48, 48);
  
  p.translate( 32, 28 );

  p.setPen( SolidLine );

  DisplaySpeed = BallSpeed/2;
  AbsWert = (DisplaySpeed.x()*DisplaySpeed.x()+DisplaySpeed.y()*DisplaySpeed.y());
  if ( AbsWert > 576 )
  {
    AbsWert = sqrt(AbsWert/576);
    DisplaySpeed = DisplaySpeed / AbsWert;
  };

  p.setBrush( gray );
  p.drawLine( DisplaySpeed,QPoint(0,0));
  p.drawEllipse( DisplaySpeed.x()-2,DisplaySpeed.y()-2, 4, 4);

  p.setBrush( black );
  p.drawLine( TiltVector,QPoint(0,0));
  p.drawEllipse( TiltVector.x()-2,TiltVector.y()-2, 4, 4);

  p.end();
  
  //p.drawPie( QRect( 8, -7, 14, 14) , 135*16, 90*16);

  setBackgroundPixmap( Abbild );
  //p.begin( this );
  //p.drawPixmap( 0,0, Abbild );

  
}

